
import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLConnection;

/**
 * This class is responsible for uploading files using http
 * 
 * @author Tresor Mvumbi
 */
public class AudioSender {

    public static void main(String args[]) {
//        try {
//            File file = new File("image.jpg");
//
//            URL url = new URL("http://localhost:8080/afrimeet/upload.jsp");
//            transmitFile(file, url);
//        } catch (Exception e) {
//            e.printStackTrace();
//        }

        try {
            String boundary = Long.toHexString(System.currentTimeMillis());
            URL u = new URL("http://localhost:8080/face/SoundReceiver?type=send");
            URLConnection c = u.openConnection();
            c.setDoOutput(true);
            
            c.setUseCaches(false);
            // set some request headers
            c.setRequestProperty(
                    "Connection",
                    "Keep-Alive");
//            System.out.println("About to create Input Stream");
//            InputStream in = c.getInputStream();
//            System.out.println("Input created");
            OutputStream out = c.getOutputStream();
            System.out.println("Output created, Connected = ");
            
            byte buf[] = new byte[1000];   
            byte i = 0;
            while(true){
                buf[0] = ++i;
                out.write(buf);
//                out.flush();
                System.out.println("Something written"+buf[0]);
                c.getInputStream();
                        
                Thread.sleep(1000);
            }
            
//            // get codebase of the this (the applet) to use for referer
//            c.setRequestProperty(
//                    "HTTP_REFERER",
//                    "UTF-8");
//            c.setRequestProperty(
//                    "Content-Type",
//                    "multipart/form-data; boundary=" + boundary);
//
//            DataOutputStream dstream = new DataOutputStream(c.getOutputStream());
//
//            for (int i = 0; i < 10; i++) {
//                byte[] data = new byte[1000];
//                dstream.write(data,0, 1000);
//                System.out.println("Something written !");
//                Thread.sleep(1000);
//            }
//            dstream.writeBytes("\r\n--" + boundary + "--\r\n");
//            dstream.flush();
//            dstream.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void transmitFile(File file, URL url) throws Exception {
        String boundary = Long.toHexString(System.currentTimeMillis());  // Just generate some unique random value
        String CRLF = "\r\n"; // Line separator required by multipart/form-data
        String charset = "UTF-8";

        HttpURLConnection connection = (HttpURLConnection) url.openConnection();
        connection.setDoOutput(true);
        connection.setDoInput(true);
        connection.setRequestProperty("Content-Type", "multipart/form-data; boundary=" + boundary);
        connection.setRequestProperty("Accept-Language", "en-us,en;q=0.5");

        OutputStream output = connection.getOutputStream();
        PrintWriter writer = new PrintWriter(new OutputStreamWriter(output, charset), true); // true = autoFlush, important!

        writer.append("--" + boundary).append(CRLF);
        writer.append("Content-Disposition: form-data; name=\"file\"; filename=\"" + file.getName() + "\"").append(CRLF);
        writer.append("Content-Type: " + URLConnection.guessContentTypeFromName(file.getName())).append(CRLF);
        writer.append("Content-Transfer-Encoding: binary").append(CRLF);
        writer.append(CRLF).flush();

        InputStream input = null;
        input = new FileInputStream(file);
        byte[] buffer = new byte[1024];
        int i = 0;
        for (int length = 0; (length = input.read(buffer)) > 0;) {
            output.write(buffer, 0, length);
            System.out.println(i++);
        }
        output.flush(); // Important! Output cannot be closed. Close of writer will close output as well.
        if (input != null) {
            input.close();
        }

        writer.append(CRLF).flush(); // CRLF is important! It indicates end of binary boundary.

        // End of multipart/form-data.
        writer.append("--" + boundary + "--").append(CRLF);

        // Read Response
        System.out.println("" + connection.getResponseCode());
        InputStream in = connection.getErrorStream();// connection.getInputStream();
        BufferedReader r = new BufferedReader(new InputStreamReader(in));
        StringBuffer buf = new StringBuffer();
        String line;
        while ((line = r.readLine()) != null) {
            buf.append(line);
            System.out.println(line);
        }
    }
}